using System;
using System.Runtime.InteropServices;

namespace MBTest
{
	//typedef struct tagPOINT {	LONG x; LONG y; } POINT, *PPOINT; 
	[Serializable]
	public struct POINT
	{
		public System.Int32	x;
		public System.Int32	y;
	};

	//struct MSG { HWND hwnd; UINT message; WPARAM wParam; LPARAM lParam;
	//			   DWORD time, POINT pt; }
	[Serializable]
	public struct MSG 
	{
		public int				hwnd;
		public System.UInt32	message;
		public System.UInt16	wParam;
		public System.Int32		lParam;
		public System.UInt32	time;
		public POINT			pt;
	};

	/// <summary>
	/// Provide C# interface to Windows library methods
	/// These methods live in the user32 and kernel32 libraries
	/// </summary>
	unsafe public class User32
	{
		public const int NULL = 0;
		public const int SW_HIDE = 0;
		public const int S_OK = 0;
		public bool SUCCEEDED(int hResult)
		{
			return (hResult >= 0);
		}
		public bool FAILED(int hResult)
		{
			return (hResult < 0);
		}
		// system dll bs
		[DllImport("user32.dll",EntryPoint="DispatchMessage")]
		public static extern int DispatchMessage(ref MSG msg);

		[DllImport("user32.dll",EntryPoint="FindWindow")]
		public static extern int FindWindow(string _ClassName, string _WindowName);

		// \"The GetMessage function retrieves a message from the calling thread's 
		//message queue. The function dispatches incoming sent messages until a 
		//posted message is available for retrieval. "
		//BOOL GetMessage( LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin,UINT wMsgFilterMax)
		[DllImport("user32.dll", EntryPoint="GetMessage")]
		public static extern int GetMessage(ref MSG lpMsg, int hWnd, uint wMsgFilterMin, uint wMsgFilterMax);

		[DllImport("kernel32.dll",EntryPoint="GetTickCount")]
		public static extern uint GetTickCount();

		[DllImport("user32.dll",EntryPoint="ShowWindow")]
		public static extern int ShowWindow(int hWnd, int showCmd);

		[DllImport("user32.dll",EntryPoint="TranslateMessage")]
		public static extern int TranslateMessage(ref MSG msg);

	}
}
