/***********************************************************
 By using this material you agree to comply with the terms
 governing the MBTI systems and with the MBTI Site Terms and
 Conditions available for view at http://www.mbtrading.com/
 Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
************************************************************/

// COrderSink.cpp : implementation file

#include "stdafx.h"
#include "NavOCq.h"
#include "COrderSink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COrderSink

IMPLEMENT_DYNAMIC(COrderSink, CCmdTarget)

COrderSink::COrderSink(CDlgLevel2* pParent)
{
	EnableAutomation();
	m_bLogonSucceeded = FALSE; // Distinguish old events (pre-OnLogonSucceeded) from new ones
	m_pParent = pParent;
}

COrderSink::~COrderSink()
{
}

void COrderSink::OnFinalRelease()
{
	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(COrderSink, CCmdTarget)
	//{{AFX_MSG_MAP(COrderSink)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(COrderSink, CCmdTarget)
	//{{AFX_DISPATCH_MAP(COrderSink)
	DISP_FUNCTION_ID(COrderSink, "OnConnect", 1, OnConnect, VT_EMPTY, VTS_I4)
	DISP_FUNCTION_ID(COrderSink, "OnClose", 2, OnClose, VT_EMPTY, VTS_I4)
	DISP_FUNCTION_ID(COrderSink, "OnLogonSucceed", 3, OnLogonSucceed, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION_ID(COrderSink, "OnSubmit", 4, OnSubmit, VT_EMPTY, VTS_DISPATCH)
	DISP_FUNCTION_ID(COrderSink, "OnAcknowledge", 5, OnAcknowledge, VT_EMPTY, VTS_DISPATCH)
	DISP_FUNCTION_ID(COrderSink, "OnExecute", 6, OnExecute, VT_EMPTY, VTS_DISPATCH)
	DISP_FUNCTION_ID(COrderSink, "OnReject", 9, OnReject, VT_EMPTY, VTS_DISPATCH)
	DISP_FUNCTION_ID(COrderSink, "OnRemove", 10, OnRemove, VT_EMPTY, VTS_DISPATCH)
	DISP_FUNCTION_ID(COrderSink, "OnHistoryAdded", 11, OnHistoryAdded, VT_EMPTY, VTS_DISPATCH)
	DISP_FUNCTION_ID(COrderSink, "OnPositionAdded", 12, OnPositionAdded, VT_EMPTY, VTS_DISPATCH)
	DISP_FUNCTION_ID(COrderSink, "OnPositionUpdated", 13, OnPositionUpdated, VT_EMPTY, VTS_DISPATCH)
	DISP_FUNCTION_ID(COrderSink, "OnBalanceUpdate", 14, OnBalanceUpdate, VT_EMPTY, VTS_DISPATCH)
	DISP_FUNCTION_ID(COrderSink, "OnSyncAccounts", 15, OnSyncAccounts, VT_EMPTY, VTS_DISPATCH)
	DISP_FUNCTION_ID(COrderSink, "OnDefaultAccountChanged", 16, OnDefaultAccountChanged, VT_EMPTY, VTS_DISPATCH)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

/*
Originally used the Class Wizard to create the above entries. It created them, plus the
macros (event handlers). The CW created them as DISP_FUNCTION (not DISP_FUNCTION_ID) and
there was a problem with MFC not assigning the right DISPID to each event handler
(e.g. OnHistoryAdded was being called when OnPositionUpdated event fired). Therefore,
manually changed them all to DISP_FUNCTION_ID as you see above, which requires the DISPID
as the 3rd parameter. The DISPIDs entered above are also listed below; copy/pasted for
your convenience (and mine...), and can also be found in the typedefs for MbtOrders.DLL.

[id(0x00000001), helpstring("Occurs upon successful connection to order server.")]
void OnConnect([in] long lErrorCode);
[id(0x00000002), helpstring("Occurs when connection to order server has been severed.")]
void OnClose([in] long lErrorCode);
[id(0x00000003), helpstring("Occurs when user has been authenticated and has successfully logged in.")]
void OnLogonSucceed();
[id(0x00000004), helpstring("Occurs upon order submission.")]
void OnSubmit([in] IMbtOpenOrder* pOrd);
[id(0x00000005), helpstring("Occurs when a submitted order has been accepted by server.")]
void OnAcknowledge([in] IMbtOpenOrder* pOrd);
[id(0x00000006), helpstring("Occurs in response to an execution against a pending order.")]
void OnExecute([in] IMbtOpenOrder* pOrd);
[id(0x00000009), helpstring("Occurs when an order submission has failed.")]
void OnReject([in] IMbtOpenOrder* pOrd);
[id(0x0000000a), helpstring("Occurs when an order is no longer pending and should be removed from user interface.")]
void OnRemove([in] IMbtOpenOrder* pOrd);
[id(0x0000000b), helpstring("Occurs when a new order event has been added to the history log.")]
void OnHistoryAdded([in] IMbtOrderHistory* pHist);
[id(0x0000000c), helpstring("Occurs when a new position has been added.")]
void OnPositionAdded([in] IMbtPosition* pPos);
[id(0x0000000d), helpstring("Occurs when there has been a change to a position.")]
void OnPositionUpdated([in] IMbtPosition* pPos);
[id(0x0000000e), helpstring("Occurs when account totals have changed.")]
void OnBalanceUpdate([in] IMbtAccount* pAcct);
[id(0x0000000f), helpstring("When SyncAccounts preference is True, occurs to request all controls to reset their account to match.")]
void OnSyncAccounts([in] IMbtAccount* pAcct);
[id(0x00000010), helpstring("Occurs when the MbtAccounts.DefaultAccount property has changed.")]
void OnDefaultAccountChanged([in] IMbtAccount* pAcct);
*/

static const IID IID_ICOrderSink =
{ 0x5a33b0a2, 0xd431, 0x484d, { 0x83, 0xd9, 0xf0, 0x8d, 0xd6, 0xd8, 0x10, 0x92 } };

BEGIN_INTERFACE_MAP(COrderSink, CCmdTarget)
//	INTERFACE_PART(COrderSink, IID_ICOrderSink, Dispatch) nope
//	INTERFACE_PART(COrderSink, DIID__IMbtOrderClientEvents, Dispatch) nope
// below, the __uuidof should use the dispinterface found in the .tlh file
	INTERFACE_PART(COrderSink, __uuidof(_IMbtOrderClientEvents), Dispatch)
END_INTERFACE_MAP()

/***************************************************************************
These five macros satisfy the event handlers (relocated to the .h file which
were originally put HERE by the Class Wizard). OnLogonSucceeded is handled in
the .h file, but the rest--pAct, pOrd, pPos, pHist, and lErrorCode--all call
one of these. OnClose only fires on loss of connection; not on shutdown.
***************************************************************************/

/* Process IMbtAccount events **********************************************
***************************************************************************/
void COrderSink::Log_pAcct(LPCTSTR sEventName, IMbtAccount* pAcct)
{
	CString sOut;
	CString sNewOrOld = NewOrOld(m_bLogonSucceeded);
	CString sAccount = (LPCTSTR)pAcct->Account;
	CString sCustomer = (LPCTSTR)pAcct->Customer;
	long lTradesToday = pAcct->TradesToday[-1];
	long lSharesToday = pAcct->SharesToday[-1];
	long lCancelsToday = pAcct->CancelsToday[-1];
	double dCurrentBP = pAcct->CurrentBP;
	double dCurrentEquity = pAcct->CurrentEquity;
	double dDailyRealizedPL = pAcct->DailyRealizedPL;
	sOut.Format("%s (pAcct) %s: %s:%s, TDs/SHs/XLs: %d/%d/%d, BP/CE/PL: $%.2f/$%.2f/$%.2f\n",
		sNewOrOld, sEventName, sAccount, sCustomer, lTradesToday, lSharesToday, lCancelsToday,
		dCurrentBP, dCurrentEquity, dDailyRealizedPL);
	TraceItOut(sOut);
}

/* Process IMbtOpenOrder events ********************************************
***************************************************************************/
void COrderSink::Log_pOrd(LPCTSTR sEventName, IMbtOpenOrder* pOrd)
{
	CString sOut;
	CString sNewOrOld = NewOrOld(m_bLogonSucceeded);
	CString sCurrentEvent = (LPCTSTR)pOrd->CurrentEvent;
	IMbtAccountPtr pAcct = pOrd->Account;
	CString sAccount = (LPCTSTR)pAcct->Account;
	CString sCustomer = (LPCTSTR)pAcct->Customer;
	CString sBuySell;
	long lBuySell = pOrd->BuySell;
	switch(lBuySell) {
		case VALUE_BUY:        sBuySell = "BUY";     break;
		case VALUE_SELL:       sBuySell = "SELL";    break;
		case VALUE_SELLSHT:    sBuySell = "SHORT";   break;
		default:               sBuySell = "?!?";
	};
	CString sRemoteID = (LPCTSTR)pOrd->RemoteID;
	double dStopLimit = pOrd->StopLimit;
	long lSharesFilled = pOrd->SharesFilled;
	long lQuantity = pOrd->Quantity;
	CString sSymbol = (LPCTSTR)pOrd->Symbol;
	double dPrice = pOrd->Price;
	CString sRoute = (LPCTSTR)pOrd->Route;
	CString sTime = (LPCTSTR)pOrd->Time;
	CString sDate = (LPCTSTR)pOrd->Date;
	CString sOrderNumber = (LPCTSTR)pOrd->OrderNumber;
	CString sToken = (LPCTSTR)pOrd->Token;
	sOut.Format("%s (pOrd)  %s: %s:%s %s %s RID:%s StpLmt: $%.2f Fld/Qty: %d/%d %s at $%.2f with %s at %s on %s. #: %s, Tkn: %s\n",
		sNewOrOld, sEventName, sAccount, sCustomer, sCurrentEvent, sBuySell,
		sRemoteID, dStopLimit, lSharesFilled, lQuantity,
		sSymbol, dPrice, sRoute, sTime, sDate, sOrderNumber, sToken);
	TraceItOut(sOut);
}

/* Process IMbtPosition events *********************************************
***************************************************************************/
void COrderSink::Log_pPos(LPCTSTR sEventName, IMbtPosition* pPos)
{
	CString sOut;
	CString sNewOrOld = NewOrOld(m_bLogonSucceeded);
	IMbtAccountPtr pAcct = pPos->Account;
	CString sAccount = (LPCTSTR)pAcct->Account;
	CString sCustomer = (LPCTSTR)pAcct->Customer;
	long lCloseableShares = pPos->CloseableShares;
	CString sSymbol = (LPCTSTR)pPos->Symbol;
	double dPNL = pPos->RealizedPNL;
	long lPendingBuyShares = pPos->PendingBuyShares;
	long lPendingSellShares = pPos->PendingSellShares;
	sOut.Format("%s (pPos)  %s: %s:%s, ClsShrs: %d pBuy/pSell: %d/%d of %s, PNL: %d\n",
		sNewOrOld, sEventName, sAccount, sCustomer, lCloseableShares, lPendingBuyShares,
		lPendingSellShares, sSymbol, dPNL);
	TraceItOut(sOut);
}

/* Process IMbtOrderHistory events *****************************************
***************************************************************************/
void COrderSink::Log_pHist(LPCTSTR sEventName, IMbtOrderHistory* pHist)
{
	CString sOut;
	CString sNewOrOld = NewOrOld(m_bLogonSucceeded);
	IMbtAccountPtr pAcct = pHist->Account;
//	CString sAccount = (LPCTSTR)pAcct->Account;
//	CString sCustomer = (LPCTSTR)pAcct->Customer;
	CString sRemoteID = (LPCTSTR)pHist->RemoteID;
	CString sEvent = (LPCTSTR)pHist->Event;
	CString sMessage = (LPCTSTR)pHist->Message;
	CString sOrderNumber = (LPCTSTR)pHist->OrderNumber;
	CString sToken = (LPCTSTR)pHist->Token;
	sMessage.TrimLeft();
	CString sBuySell;
	long lBuySell = pHist->BuySell;
	switch(lBuySell) {
		case VALUE_BUY:        sBuySell = "BUY";     break;
		case VALUE_SELL:       sBuySell = "SELL";    break;
		case VALUE_SELLSHT:    sBuySell = "SHORT";   break;
		default:               sBuySell = "?!?";
	};
	long lSharesFilled = pHist->SharesFilled;
	long lQuantity = pHist->Quantity;
	CString sSymbol = (LPCTSTR)pHist->Symbol;
	CString sTime = (LPCTSTR)pHist->Time;
	CString sDate = (LPCTSTR)pHist->Date;
	double dPrice = pHist->Price;
	CString sRoute = (LPCTSTR)pHist->Route;
	sOut.Format("%s (pHist) %s: RID:%s %s %s, %d/%d, %s, $%.2f with %s at %s on %s. #: %s, Tkn: %s Msg: %s\n",
		sNewOrOld, sEventName, sRemoteID, sEvent, sBuySell, lSharesFilled, lQuantity,
		sSymbol, dPrice, sRoute, sTime, sDate, sOrderNumber, sToken, sMessage);
	TraceItOut(sOut);
}

/* Process events with lErrorCode ******************************************
***************************************************************************/
void COrderSink::Log_ErrorCode(LPCTSTR sEventName, long lErrorCode)
{
	CString sOut;
	sOut.Format("----  %s ------- error code: %d --------------------\n", sEventName, lErrorCode);
	TraceItOut (sOut);
}
