/***********************************************************
 By using this material you agree to comply with the terms
 governing the MBTI systems and with the MBTI Site Terms and
 Conditions available for view at http://www.mbtrading.com/
 Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
************************************************************/

// DlgLevel2.cpp : implementation file

#include "stdafx.h"
#include "NavOCq.h"
#include "DlgLevel2.h"
#include "COrderSink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgLevel2 dialog

/*
 *	This is only a demonstration, therefore we are requesting ALL levels of
 * service. Under normal circumstances you would only be requesting one or
 * two: L1 and T&S, or L1 and L2, or L2 and T&S, or only Options, etc.
 * Uncomment only ONE of the following (see the file QuoteSink.h for details).
 *********************************************************************/
	IMPLEMENT_MBTQUOTESNOTIFY_ALL_SINK(CDlgLevel2)
//	IMPLEMENT_MBTQUOTESNOTIFY_L1_SINK(CDlgLevel2)      - Level I (aka Quotes) only
//	IMPLEMENT_MBTQUOTESNOTIFY_L2_SINK(CDlgLevel2)      - Level II only
//	IMPLEMENT_MBTQUOTESNOTIFY_TS_SINK(CDlgLevel2)      - Time and Sales only
//	IMPLEMENT_MBTQUOTESNOTIFY_OPTIONS_SINK(CDlgLevel2) - Options only
//	IMPLEMENT_MBTQUOTESNOTIFY_L1_L2_SINK(CDlgLevel2)   - Levels I and II
//	IMPLEMENT_MBTQUOTESNOTIFY_L2_TS_SINK(CDlgLevel2)   - Level II and T&S
// ---------------------------------------------------- make sense?

CDlgLevel2::CDlgLevel2(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgLevel2::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgLevel2)
	m_sSymbol = __T("");
	m_sAccountSemiDelimited = __T("");
	m_sConame = __T("");
	pUnk = NULL;
	m_pSink = NULL;
	m_svcLevelFlags = NULL;
	m_bLevelOneForced = FALSE;
	m_lForceLevelOne = qsfLevelOne;
	//}}AFX_DATA_INIT

	EnableAutomation();
	LPDISPATCH pDisp = GetIDispatch(FALSE);   // No AddRef() here
	m_pQNotify = pDisp;                       // Automatic QI by smart ptr
	ASSERT( NULL != m_pQNotify );

	// Instantiate the sink object
	m_pSink = new COrderSink(this);
	ASSERT( NULL != m_pSink );

	// Get IUnknown interface for [out] event sink object
	LPUNKNOWN pUnk = m_pSink->GetIDispatch(FALSE);
	ASSERT( NULL != pUnk );

	// Fetch our pointer to the Order Client
	m_pOrders = theApp.m_pComMgr->OrderClient;
	if( NULL == m_pOrders )
	{
		AfxMessageBox("Could not set OrderClient !", MB_ICONINFORMATION);
	}
	else
	{
		// Extract some data, 'cause we can...
		CString sMsg;
		CString sUserName =(LPCTSTR)m_pOrders->UserName;
		CString sRemoteAddress =(LPCTSTR)m_pOrders->RemoteAddress;
		sMsg.Format("#### UID: %s, IP:%s\n",
			sUserName, sRemoteAddress);
		TRACE(sMsg);
	}

	// Fetch our pointer to the Quotes object. With this, we will advise and
	// unadvise symbols with appropriate levels of service (below)
	m_pQuotes = theApp.m_pComMgr->Quotes;
	if( NULL == m_pQuotes )
	{
		AfxMessageBox("Could not instantiate Quotes object !", MB_ICONINFORMATION);
	}

	// Wire our sink into ComMgr - this is to receive OrderClient events to stick
	// into the first (large) RichEdit
	ASSERT( NULL != theApp.m_pComMgr );
	if( NULL == theApp.m_pComMgr || !AfxConnectionAdvise(
		m_pOrders,
		__uuidof(_IMbtOrderClientEvents), pUnk, FALSE, &m_dwCookie)
		)
	{
		AfxMessageBox("WARNING: Failed to advise MbtComMgr events");
	}

}

void CDlgLevel2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgLevel2)
	DDX_Control(pDX, IDC_ctlChkOptions, m_ctlChkOptions);
	DDX_Control(pDX, IDC_ctlChkL2, m_ctlChkL2);
	DDX_Control(pDX, IDC_ctlChkTS, m_ctlChkTS);
	DDX_Control(pDX, IDC_ctlChkQuotes, m_ctlChkQuotes);
	DDX_Control(pDX, IDC_lblCompanyName, m_ctlCompanyName);
	DDX_Control(pDX, IDC_MBTL2CTRL1, m_ctlLevel2);
	DDX_Control(pDX, IDC_RICHEDIT1, m_ctlRichEdit);  // Order Client event logging
	DDX_Control(pDX, IDC_lstQuotes, m_ctlLstQuotes);
	DDX_OCText(pDX, IDC_MBTL2CTRL1, DISPID(102), m_sSymbol);
	DDX_OCText(pDX, IDC_MBTL2CTRL1, DISPID(101), m_sAccountSemiDelimited);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgLevel2, CDialog)
	//{{AFX_MSG_MAP(CDlgLevel2)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_ctlChkL2, OnctlChkL2)
	ON_BN_CLICKED(IDC_ctlChkOptions, OnctlChkOptions)
	ON_BN_CLICKED(IDC_ctlChkQuotes, OnctlChkQuotes)
	ON_BN_CLICKED(IDC_ctlChkTS, OnctlChkTS)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_INTERFACE_MAP(CDlgLevel2, CDialog)
		INTERFACE_PART(CDlgLevel2, __uuidof(IMbtQuotesNotify), MbtQuotesNotify)
END_INTERFACE_MAP()

void CDlgLevel2::OnSize(UINT nType, int winWidth, int winHeight) 
{
	/* OnSize is always called initially. Therefore, placement of controls during
	   design is unnecessary, as we can always place and size them HERE.
	*****************************************************************************/

	CDialog::OnSize(nType, winWidth, winHeight); // fetch current window dimensions

	/* Hold to max width and height for the Level II control, then size everything
		else around it, filling out rest of window. We also fudge dimensions a few twips
		here and there for nice bordering around controls ( + 3, + 4, + 10, etc.)
	*****************************************************************************/
	int iL2w, iL2h;
	iL2w = min(winWidth, 575);    // calc max L2 width
	iL2h = min(winHeight, 325);   // calc max L2 height, and then set it:
	m_ctlLevel2.SetWindowPos(&m_ctlLevel2, 0, 0, iL2w, iL2h, SWP_NOZORDER|SWP_SHOWWINDOW);

	// The following L2 control sub-pane dimensions seem about right:
	m_ctlLevel2.SetQQHeight(80);
	m_ctlLevel2.SetOEHeight(100);
	m_ctlLevel2.SetTickerWidth(135);

	// RichEdit LEFT is window left, TOP is L2 bottom (iL2h),
	// WIDE as window, TALL as window less L2 height (winHeight - iL2h)
	m_ctlRichEdit.SetWindowPos(&m_ctlRichEdit,
		1,                      // left
		iL2h + 1,               // top
		winWidth - 3,           // width
		winHeight - (iL2h + 3), // height
		SWP_NOZORDER|SWP_SHOWWINDOW);

	// ListBox LEFT is L2 right, TOP is window top less static text Company Name
	// WIDE as window less L2 width, TALL as window height less L2 height less buttons
	m_ctlLstQuotes.SetWindowPos(&m_ctlLstQuotes,
		iL2w + 1,
		32,
		winWidth - (iL2w + 3),
		iL2h - 78,
		SWP_NOZORDER|SWP_SHOWWINDOW);

	// Static text box: Company Name LEFT is L2 right, TOP is window top,
	// WIDE as window less L2 width, TALL enough for two lines of display
	// NOTE: qsfLevelOne level of service is the only level that gives us
	//       the company name (see below for more on levels of service),
	//       therefore if Level I is not requested, we force it just long
	//       enough to extract the company name from the quote callback.
	m_ctlCompanyName.SetWindowPos(&m_ctlCompanyName,
		iL2w + 1,
		1,
		winWidth - (iL2w + 3),
		30,
		SWP_NOZORDER|SWP_SHOWWINDOW);


	/* Size and position check boxes. They let us choose the levels of service
	   we desire. Also set the labels' text and their initial state to FALSE.
	   Got some fancy sizing here, and also make sure to visit the check boxes'
	   properties -- Auto and Push-like are checked -- makes 'em like push-buttons.
	*****************************************************************************/

	// Level I (aka Quotes)
	m_ctlChkQuotes.SetWindowPos(&m_ctlChkQuotes,
		iL2w + 3,                               // left
		iL2h - 43,                              // top
		(winWidth - (iL2w + 10)) / 2,           // width
		19,                                     // height
		SWP_NOZORDER|SWP_SHOWWINDOW);
	SetDlgItemText(IDC_ctlChkQuotes, "Quotes");
	CheckDlgButton(IDC_ctlChkQuotes, FALSE);

	// Level II
	m_ctlChkL2.SetWindowPos(&m_ctlChkL2,
		iL2w + ((winWidth - (iL2w + 3)) / 2) + 4,
		iL2h - 43,
		(winWidth - (iL2w + 10)) / 2,
		19,
		SWP_NOZORDER|SWP_SHOWWINDOW);
	SetDlgItemText(IDC_ctlChkL2, "Level II");
	CheckDlgButton(IDC_ctlChkL2, FALSE);

	// Time and Sales
	m_ctlChkTS.SetWindowPos(&m_ctlChkTS,
		iL2w + 3,
		iL2h - 20,
		(winWidth - (iL2w + 10)) / 2,
		19,
		SWP_NOZORDER|SWP_SHOWWINDOW);
	SetDlgItemText(IDC_ctlChkTS, "T&&S");
	CheckDlgButton(IDC_ctlChkTS, FALSE);

	// Options
	m_ctlChkOptions.SetWindowPos(&m_ctlChkOptions,
		iL2w + ((winWidth - (iL2w + 3)) / 2) + 4,
		iL2h - 20,
		(winWidth - (iL2w + 10)) / 2,
		19,
		SWP_NOZORDER|SWP_SHOWWINDOW);
	SetDlgItemText(IDC_ctlChkOptions, "Options");
	CheckDlgButton(IDC_ctlChkOptions, FALSE);

}

/////////////////////////////////////////////////////////////////////////////
// CDlgLevel2 message handlers

BOOL CDlgLevel2::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Do any Level II control initialization here
	m_ctlLevel2.SetCaptionBarVisible(TRUE);

	// Initialize our RichEdit font
	CHARFORMAT cfm;
	cfm.cbSize = sizeof(cfm);
	cfm.yHeight = 160; // 20 twips per point(e.g. 170 = 8.5pt and 100 = 5pt)
	cfm.dwMask = CFM_SIZE | CFM_FACE;
	strcpy(cfm.szFaceName, _T("Courier New"));
	m_ctlRichEdit.SetDefaultCharFormat(cfm);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BEGIN_EVENTSINK_MAP(CDlgLevel2, CDialog)
    //{{AFX_EVENTSINK_MAP(CDlgLevel2)
	ON_EVENT(CDlgLevel2, IDC_MBTL2CTRL1, 300 /* OnAccountChanged */, OnAccountChangedMbtl2ctrl1, VTS_DISPATCH)
	ON_EVENT(CDlgLevel2, IDC_MBTL2CTRL1, 301 /* OnSymbolChanged */, OnSymbolChangedMbtl2ctrl1, VTS_BSTR)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CDlgLevel2::OnAccountChangedMbtl2ctrl1(LPDISPATCH pNewAcct) 
{
	if( pNewAcct )
	{
		IMbtAccountPtr pAcct(pNewAcct);
		m_sAccountSemiDelimited =(LPCTSTR)pAcct->SemiDelimited;
		SetCaption();
	}
}

void CDlgLevel2::OnSymbolChangedMbtl2ctrl1(LPCTSTR Symbol) 
{
	if( Symbol )
	{
		// Save symbol in member var,, stuff into Level II caption,
		// and then advise our new symbol for quotes based on check boxes.
		m_sSymbol = Symbol;
		SetCaption();
		AdviseNewSymbol();
	}
}

/* AdviseNewSymbol() - Query the check boxes to determine which levels of
	service are desired. Build our flag, and then pass it along in the
	AdviseSymbol method below. Look in MbtSDK.chm for details on the four
	possible levels of service (enumQuoteServiceFlags). They are also
	found in the type library for MbtQuotes and are ORed together:
		1 - qsfLevelOne
		2 - qsfLevelTwo
		4 - qsfTimeAndSales
		8 - qsfOptions
*****************************************************************************/
void CDlgLevel2::AdviseNewSymbol()
{
	// Clear the quotes listbox:
	m_ctlLstQuotes.ResetContent();

	// OR together our chosen flags (check boxes):
	m_svcLevelFlags  = ( m_ctlChkQuotes.GetCheck()  ? qsfLevelOne : 0 );
	m_svcLevelFlags += ( m_ctlChkL2.GetCheck()      ? qsfLevelTwo : 0 );
	m_svcLevelFlags += ( m_ctlChkTS.GetCheck()      ? qsfTimeAndSales : 0 );
	m_svcLevelFlags += ( m_ctlChkOptions.GetCheck() ? qsfOptions : 0 );

	CString sOut;
	sOut.Format("--- Level of Service Flags: %d ---", m_svcLevelFlags);
	m_ctlLstQuotes.InsertString(0, sOut);

	/*** IMPORTANT NOTE *** UnadviseAll is not only the least expensive way to
	    clear all symbols' advisories (if you need to clear them ALL), but you
		also MUST call it before destroying the pointer in OnDestroy() below.
	*************************************************************************/
	m_pQuotes->UnadviseAll( m_pQNotify );
	m_pQuotes->AdviseSymbol( m_pQNotify, (LPCTSTR)m_sSymbol, m_svcLevelFlags );

	/* If Level I (Quotes) has not been advised, then force this symbol's
	   Level I service level advisement (and set m_bCoNameAdvised = TRUE) so
	   we can extract the new symbol's Company Name field. Once we have the
	   Company Name field, unadvise it in OnQuoteData.
	*************************************************************************/
	if( !(m_svcLevelFlags&qsfLevelOne) )
	{
		m_pQuotes->AdviseSymbol( m_pQNotify, (LPCTSTR)m_sSymbol, m_lForceLevelOne );
		TRACE( "   + adding %s manually with level %d\n", m_sSymbol, m_lForceLevelOne );
		m_bLevelOneForced = TRUE;
	}

	CString sForced;
	sForced = m_bLevelOneForced ? " L1 Forced" : "";

	CString sLevels;
	sLevels.Format(" with service levels: %d", m_svcLevelFlags);

	CString sBuf;
	sBuf.Format(m_sSymbol + " %s%s", sForced, sLevels);

	m_ctlRichEdit.GetWindowText( sOut );
	m_ctlRichEdit.SetWindowText( sOut + "\r\n" + sBuf );

}


/* Check box handlers - simply invoke AdviseNewSymbol(), which does all the work:
*****************************************************************************/
void CDlgLevel2::OnctlChkQuotes()  { AdviseNewSymbol(); }
void CDlgLevel2::OnctlChkL2()      { AdviseNewSymbol(); }
void CDlgLevel2::OnctlChkTS()      { AdviseNewSymbol(); }
void CDlgLevel2::OnctlChkOptions() { AdviseNewSymbol(); }


/* Our Quote data callback methods. Here, you can pull any of the fields found
	in the four UDT Structures - see the MbtSDK.chm Help file: UDTs (structures)
*****************************************************************************/
HRESULT CDlgLevel2::OnQuoteData(QUOTERECORD* pQuote)
{
	CString sOut;
	double dLast = pQuote->dLast;
	long lSize = pQuote->lLastSize;
	long lVol = pQuote->lVolume;
	COleDateTime cTime(pQuote->UTCDateTime);
	sOut.Format("L1  $%.2f  %d   %d  %s %s", dLast, lSize, lVol, cTime.Format("%m/%d/%y"), cTime.Format("%H:%M:%S"));
	m_ctlLstQuotes.InsertString(0, sOut);

	// Set the company name in the static text control Level 1 data is the
	// only level of service that gives us this.
	CString sCompanyName( pQuote->bstrCompany);
	sCompanyName.Replace(" - ", "\r\n");
	SetDlgItemText(IDC_lblCompanyName, sCompanyName);

	/* If Level I quotes were advised by force on this symbol, that means the
	   Level I check box was not checked (and m_bLevelOneForced = TRUE),
	   therefore, grab our Company Name and unadvise Level I on this symbol.
	*************************************************************************/
	if( m_bLevelOneForced && sCompanyName.GetLength() > 5 ) // arbitrary CoName length...
	{
		m_pQuotes->UnadviseSymbol( m_pQNotify, (LPCTSTR)m_sSymbol, m_lForceLevelOne );
		TRACE( "   - removing %s manually with level %d\n", m_sSymbol, m_lForceLevelOne );
		TRACE( "   = Company name [[[%s]]] = %d\n", sCompanyName, sCompanyName.GetLength() );
		m_bLevelOneForced = FALSE;
	}
	return S_OK;
}

HRESULT CDlgLevel2::OnLevel2Data(LEVEL2RECORD* pQuote)
{
	CString sOut;
	long lSize = pQuote->lSize;
	CString sMMID(pQuote->bstrMMID);
	CString sSource(pQuote->bstrSource);
	double dPrice = pQuote->dPrice;
	long lSide(pQuote->side);
	COleDateTime cTime(pQuote->UTCTime);
	CString sTime = cTime.Format("%H:%M:%S");
	sOut.Format("L2  %d  <%s>  [%s]  $%.2f  [%d] <%g>{%s}", lSize, sMMID, sSource, dPrice, lSide, cTime.m_dt, cTime.Format("%H:%M:%S"));
	m_ctlLstQuotes.InsertString(0, sOut);
	return S_OK;
}

HRESULT CDlgLevel2::OnTSData(TSRECORD* pQuote)
{
	CString sOut;
	double dPrice = pQuote->dPrice;
	long lSize = pQuote->lSize;
//	CString sTime( pQuote->bstrTime );
	COleDateTime cTime(pQuote->UTCTime);
	sOut.Format("TS  $%.2f  %d   %s", dPrice, lSize, cTime.Format("%H:%M:%S"));
	m_ctlLstQuotes.InsertString(0, sOut);
	return S_OK;
}

HRESULT CDlgLevel2::OnOptionsData(OPTIONSRECORD* pQuote)
{
	CString sOut;
	long lLastSize = pQuote->lLastSize;
	CString sSymbol(pQuote->bstrSymbol);
	double dStrikePrice = pQuote->dStrikePrice;
	double dLast = pQuote->dLast;
	COleDateTime cTime(pQuote->UTCDateTime);
	sOut.Format("OP  %d  %s  $%.2f  $%.2f  %s %s", lLastSize, sSymbol, dStrikePrice, dLast, cTime.Format("%m/%d/%y"), cTime.Format("%H:%M:%S"));
	m_ctlLstQuotes.InsertString(0, sOut);
	return S_OK;
}


void CDlgLevel2::SetCaption()
{
	CString sCaption;
	sCaption = m_sSymbol + " - " + m_sAccountSemiDelimited;
	if( m_ctlLevel2 )
	{
		m_ctlLevel2.SetCaption(sCaption);
	}
}


/* Clean up - It is MOST IMPORTANT that you call the Unadvise method here
	before shutting down.
*****************************************************************************/
void CDlgLevel2::OnDestroy() 
{
	// Unadvise all symbols and remove our reference to the callback
	// interface from quote object
	ASSERT( NULL != m_pQNotify );
	m_pQuotes->UnadviseAll( m_pQNotify );  //------ VERY IMPORTANT!
	m_pQuotes = NULL;
	m_pQNotify = NULL;     // Releases the interface

	// UNwire our ComMgr sink
	ASSERT( NULL != m_pSink );
	LPUNKNOWN m_pUnk = m_pSink->GetIDispatch(FALSE);
	AfxConnectionUnadvise(m_pOrders, __uuidof(_IMbtOrderClientEvents), m_pUnk, FALSE, m_dwCookie);
	if( NULL != m_pSink )
	{
		delete m_pSink; // *** THE SINK DTOR MUST BE PUBLIC OR COMPILER WILL COMPLAIN ***
		m_pSink = NULL;
	}
  	m_pOrders = NULL;

	CDialog::OnDestroy();
}

