/***********************************************************
 By using this material you agree to comply with the terms
 governing the MBTI systems and with the MBTI Site Terms and
 Conditions available for view at http://www.mbtrading.com/
 Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
************************************************************/

//{{AFX_INCLUDES()
#include "mbtl2.h"
//}}AFX_INCLUDES
#if !defined(AFX_DLGLEVEL2_H__B0083FBC_9176_4E2A_8C5A_4E925DEF3FFF__INCLUDED_)
#define AFX_DLGLEVEL2_H__B0083FBC_9176_4E2A_8C5A_4E925DEF3FFF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "QuoteSink.h" // Predefine several possible quote callback scenarios

// DlgLevel2.h : header file

/////////////////////////////////////////////////////////////////////////////
// CDlgLevel2 dialog

struct _IMbtOrderClientEvents;
class COrderSink;

class CDlgLevel2 : public CDialog
{
// Construction
public:
	CDlgLevel2(CWnd* pParent = NULL);   // standard constructor
	IMbtOrderClientPtr m_pOrders;
	IMbtQuotesPtr m_pQuotes;
	IMbtQuotesNotifyPtr m_pQNotify;
	_IMbtOrderClientEvents* m_pSrc;
	LPUNKNOWN pUnk;
	COrderSink* m_pSink;
	DWORD m_dwCookie;

// Dialog Data
	//{{AFX_DATA(CDlgLevel2)
	enum { IDD = IDD_LEVEL2 };
	CListBox	m_ctlLstQuotes;
	CButton	m_ctlChkOptions;
	CButton	m_ctlChkL2;
	CButton	m_ctlChkTS;
	CButton	m_ctlChkQuotes;
	CStatic	m_ctlCompanyName;
	CMbtL2	m_ctlLevel2;
	CRichEditCtrl m_ctlRichEdit;
	CString	m_sSymbol;
	CString	m_sAccountSemiDelimited;
	CString	m_sConame;
	long     m_svcLevelFlags;
	bool     m_bLevelOneForced;
	long     m_lForceLevelOne;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgLevel2)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgLevel2)
	virtual BOOL OnInitDialog();
	afx_msg void OnAccountChangedMbtl2ctrl1(LPDISPATCH pNewAcct);
	afx_msg void OnSymbolChangedMbtl2ctrl1(LPCTSTR Symbol);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnctlChkL2();
	afx_msg void OnctlChkOptions();
	afx_msg void OnctlChkQuotes();
	afx_msg void OnctlChkTS();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	DECLARE_INTERFACE_MAP()
	// This will set up the nested m_xMbtQuotesNotify
	DECLARE_MBTQUOTESNOTIFY_INTERFACE_PART()

	// Quote callbacks - declared here, defined in .cpp file
	virtual HRESULT OnQuoteData(QUOTERECORD* pQuote);
	virtual HRESULT OnLevel2Data(LEVEL2RECORD* pQuote);
	virtual HRESULT OnTSData(TSRECORD* pQuote);
	virtual HRESULT OnOptionsData(OPTIONSRECORD* pQuote);

private:
	void SetCaption();
	void CDlgLevel2::AdviseNewSymbol();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGLEVEL2_H__B0083FBC_9176_4E2A_8C5A_4E925DEF3FFF__INCLUDED_)
