/***********************************************************
 By using this material you agree to comply with the terms
 governing the MBTI systems and with the MBTI Site Terms and
 Conditions available for view at http://www.mbtrading.com/
 Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
************************************************************/

// NavOCq.cpp : Defines the class behaviors for the application.

#include "stdafx.h"
#include "NavOCq.h"
#include "NavOCqDlg.h"
#include "DlgLevel2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNavOCqApp

BEGIN_MESSAGE_MAP( CNavOCqApp, CWinApp )
	//{{AFX_MSG_MAP( CNavOCqApp )
	//}}AFX_MSG
	ON_COMMAND( ID_HELP, CWinApp::OnHelp )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNavOCqApp construction

CNavOCqApp::CNavOCqApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CNavOCqApp object

CNavOCqApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CNavOCqApp initialization

BOOL CNavOCqApp::InitInstance()
{
	// Initialize OLE libraries
	if( !AfxOleInit() )
	{
		AfxMessageBox( IDP_OLE_INIT_FAILED );
		return FALSE;
	}

	// Init the RichEdit control
	if( !AfxInitRichEdit() )
	{
		AfxMessageBox( "NavOCq.cpp: Could not afxInitRichEdit() !", MB_ICONINFORMATION );
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	if( RunEmbedded() || RunAutomated() )
	{
		COleTemplateServer::RegisterAll();
	}
	else
	{
		COleObjectFactory::UpdateRegistryAll();
	}

	// Create instance of MbtComMgr
	if( FAILED( m_pComMgr.CreateInstance( ( __uuidof( MbtComMgr ) ) ) ) )
	{
		AfxMessageBox( "Could not instantiate MbtComMgr !", MB_ICONINFORMATION );
		return FALSE;
	}

	// Do our login
	long lHostId = 9;
	bstr_t bstrHostVersion = "0";
	if( !theApp.m_pComMgr->DoLogin( lHostId, "", "", bstrHostVersion ) )
	{
		AfxMessageBox( "DoLogin() was interrupted !", MB_ICONINFORMATION );
		return FALSE;
	}
	else
	{
		// Just for fun...
		CString sMsg;
		CString sUserName =( LPCTSTR )m_pComMgr->UserName;
		long lHostId = m_pComMgr->HostId;
		long lCustomerType = m_pComMgr->CustomerType;
		sMsg.Format( "#### UID: %s HostID: %d, CustomerType: %d\n",
			sUserName, lHostId, lCustomerType );
		TRACE( sMsg );
	}

	// Hide the splash so we can see while debugging
	HWND hWndSplash = ::FindWindow( NULL, "MbtNavSplash" );
	if( hWndSplash )
		::ShowWindow( hWndSplash, SW_HIDE );

	// L2 dialog variable
	CDlgLevel2 dlgLevel2;

	// Create the L2 dialog and show it
	dlgLevel2.Create( dlgLevel2.IDD );
	dlgLevel2.ShowWindow( SW_SHOW );
	dlgLevel2.SetWindowPos( &dlgLevel2, 200, 0, 775, 775, SWP_NOZORDER|SWP_SHOWWINDOW );

	// Create our main dialog variable and DoModal
	CNavOCqDlg dlg;
	m_pMainWnd = &dlg;
	dlg.DoModal();

	// We're back. Destroy the L2 window
	dlgLevel2.DestroyWindow();

	return FALSE;
}

int CNavOCqApp::ExitInstance() 
{
	// Clean up - It is imperative that, even if you are using smart
	// pointers, to release the smart pointers in ExitInstance before
	// calling the superclass -- because CWinApp's ExitInstance
	// uninitializes COM, and that is a frequent cause of ACCESS
	// VIOLATIONs if you don't release them here.
	m_pComMgr = NULL;
	return CWinApp::ExitInstance();
}
