VERSION 5.00
Object = "{3AF128DE-C93E-409B-8402-964D81E36F93}#1.0#0"; "MbtGrids.ocx"
Begin VB.Form frmOptChain 
   Caption         =   "Options Chain"
   ClientHeight    =   4785
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8595
   Icon            =   "frmOptChain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4785
   ScaleWidth      =   8595
   StartUpPosition =   3  'Windows Default
   Begin MBTGRIDSLib.MbtOptChain MbtOptChainCtl 
      Height          =   4575
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   8295
      _Version        =   65536
      _ExtentX        =   14631
      _ExtentY        =   8070
      _StockProps     =   2
      Caption         =   "Options Chain -  (No Accounts) "
   End
End
Attribute VB_Name = "frmOptChain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
Option Explicit

' Most of this stuff is culled verbatim from frmLevel2, so in the absense
' of comments, take a peek in there!
Implements IMbtQuotesNotify

Private m_sCompany As String
Private m_sUnderlier As String

Private Sub Form_Load()
    m_sUnderlier = MbtOptChainCtl.Underlier
    SetCaption
    SerializeForm Me, False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' This is VERY important. You MUST make sure this form's quote callback
    ' interface has been released. Failure to do so will result in unexplained crashes!
    frmMain.ComMgr.Quotes.UnadviseAll Me
    SerializeForm Me, True
End Sub

Private Sub Form_Resize()
    MbtOptChainCtl.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub SetCaption()
    Dim sCompany As String
    If Len(m_sCompany) Then
        sCompany = "- " & m_sCompany & " "
    End If
    Caption = "Options Chain " & sCompany & "[" & FormatAccount(MbtOptChainCtl.Account) & "]"
End Sub

Private Sub MbtOptChainCtl_OnAccountChanged(ByVal pNewAccount As Object)
    ' This event is fired in cases where the user has multiple accts, and has changed the contained OE's acct.
    ' Here, you probably want to update your titlebar etc to reflect the currently loaded acct
    Debug.Print "MbtOptChainCtl_OnAccountChanged"

    SetCaption
End Sub

Private Sub MbtOptChainCtl_OnPutCallChanged(ByVal PutCall As Long)
    ' This event is fired when user has changed view settings from either put or call
    ' to put *and* call. We're not going to do anything except print a debug message here.
    Debug.Print "MbtOptChainCtl_OnPutCallChanged"
End Sub

Private Sub MbtOptChainCtl_OnUnderlierChanged(ByVal Underlier As String)
    ' Fired when user has entered a new symbol in the L1 area
    Debug.Print "MbtOptChainCtl_OnUnderlierChanged"
    
    m_sUnderlier = Underlier
    m_sCompany = m_sUnderlier ' We'll default the company name to just the symbol in case we can't get a quote

    SetCaption
    
    ' To demonstrate the quote api, we will temporarily advise a L1 quote for this newly entered
    ' symbol just until we get a company name for it, after which we will unadvise
    If Len(Underlier) Then
        ' Register our callback interface to receive L1 quotes for the new underlier
        frmMain.ComMgr.Quotes.AdviseSymbol Me, Underlier, qsfLevelOne
    End If

End Sub

'-------------------------------------------------------------------------------
' IMbtQuotesNotify callback interface...
' Even though we are only interested in getting level one quotes in this module,
' we still have to implement all of these callback handlers since we are implementing
' an entire interface.

Private Sub IMbtQuotesNotify_OnQuoteData(pQuote As MBTQUOTELib.QUOTERECORD)
    If pQuote.bstrSymbol = m_sUnderlier Then
        m_sCompany = pQuote.bstrCompany
        'We're done receiving all quotes so tell quotes component to release our callback interface
        frmMain.ComMgr.Quotes.UnadviseAll Me
        SetCaption
    End If
End Sub

Private Sub IMbtQuotesNotify_OnLevel2Data(pRec As MBTQUOTELib.LEVEL2RECORD)
End Sub

Private Sub IMbtQuotesNotify_OnOptionsData(pRec As MBTQUOTELib.OPTIONSRECORD)
End Sub

Private Sub IMbtQuotesNotify_OnTSData(pRec As MBTQUOTELib.TSRECORD)
End Sub

