/***********************************************************
 By using this material you agree to comply with the terms
 governing the MBTI systems and with the MBTI Site Terms and
 Conditions available for view at http://www.mbtrading.com/
 Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
************************************************************/

// CConsoleQuotes.h

#if !defined(AFX_CConsoleQuotes_H__CFCF21FA_13B8_454F_AA61_19346E72256D__INCLUDED_)
#define AFX_CConsoleQuotes_H__CFCF21FA_13B8_454F_AA61_19346E72256D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "QuoteSink.h"

struct CurrentQuote // stuffed on callback, used by main()
{
	CString sTime;
	double dLast;
	double dBid;
	double dAsk;
	long lVol;
	CString eTick;  // "u" or "d"
};

#define tickEvenUp 0;
#define tickDown 1;
#define VALUE_BUY 10000;
#define VALUE_SELL 10001;
#define VALUE_LIMIT 10030;
#define VALUE_MARKET 10031;
#define VALUE_DAY 10011;
#define VALUE_NORMAL 10042;


class CConsoleQuotes : public CCmdTarget
{
	DECLARE_DYNAMIC(CConsoleQuotes)
public:
	CConsoleQuotes(IMbtQuotesPtr& m_pQuotes);
	virtual ~CConsoleQuotes();

	bool DoAdvise(LPCTSTR pszSymbol);
	inline bool GotQuote() { return m_bGotQuote; }
	inline SetQuoteWaiting() { m_bGotQuote = FALSE; }
	inline const CurrentQuote& GetLastQuote() { return m_lastQuote; }

protected:
	IMbtQuotesPtr m_pQuotes;
	IMbtQuotesNotifyPtr	m_pQNotify;
	bool m_bGotQuote;
	CurrentQuote m_lastQuote;

	DECLARE_INTERFACE_MAP()

	DECLARE_MBTQUOTESNOTIFY_INTERFACE_PART()

	// Quote callbacks - declared here, defined in .cpp file
	virtual HRESULT OnQuoteData(QUOTERECORD* pQuote);
	virtual HRESULT OnLevel2Data(LEVEL2RECORD* pQuote);
	virtual HRESULT OnTSData(TSRECORD* pQuote);
	virtual HRESULT OnOptionsData(OPTIONSRECORD* pQuote);
};

#endif // !defined(AFX_CConsoleQuotes_H__CFCF21FA_13B8_454F_AA61_19346E72256D__INCLUDED_)
