VERSION 5.00
Begin VB.Form frmAccounts 
   Caption         =   "Extract Accounts"
   ClientHeight    =   7515
   ClientLeft      =   1065
   ClientTop       =   345
   ClientWidth     =   5985
   LinkTopic       =   "Form1"
   ScaleHeight     =   7515
   ScaleWidth      =   5985
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear Screen"
      Height          =   375
      Left            =   4440
      TabIndex        =   2
      Top             =   1080
      Width           =   1455
   End
   Begin VB.CommandButton cmdLogin 
      Caption         =   "Log In"
      Height          =   375
      Left            =   4440
      TabIndex        =   0
      Top             =   120
      Width           =   1455
   End
   Begin VB.CommandButton cmdReturnAccounts 
      Caption         =   "Return Accounts"
      Height          =   375
      Left            =   4440
      TabIndex        =   1
      Top             =   600
      Width           =   1455
   End
End
Attribute VB_Name = "frmAccounts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
' Quick demonstration of the correct way to instantiate the ComMgr
' singleton, reference the Order Client, and fetch accounts.
'
' Always remember to destroy objects that you've created in
' reverse order of their creation.
'
' 03/08/2004 - Phil - Added For/Each, and LockItems/UnlockItems
' for the For/Next example.
'
' Compatible with Navigator Version 10.13.0.4 and up
'

Option Explicit
Public WithEvents ComMgr As MbtComMgr
Attribute ComMgr.VB_VarHelpID = -1
Public WithEvents OrderClient As MbtOrderClient
Attribute OrderClient.VB_VarHelpID = -1
Public bLoggedIn As Boolean

Private Sub Form_Load()
   cmdLogin.Enabled = True
   cmdReturnAccounts.Enabled = False
   Set ComMgr = New MbtComMgr
   Set OrderClient = ComMgr.OrderClient
   OrderClient.OnDemandMode = True
   Me.Caption = Me.Caption & " - Nav ver: " & ComMgr.NavVersion
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Set OrderClient = Nothing
   Set ComMgr = Nothing
   Unload Me
End Sub

Private Sub cmdLogin_Click()
   bLoggedIn = ComMgr.DoLogin(9, "", "", "")
   Print "Logged in: " & bLoggedIn
   Print
   If bLoggedIn Then cmdLogin.Enabled = False
End Sub

Private Sub OrderClient_OnLogonQueryWitholdHistory(pbWithold As Boolean)
   pbWithold = False
End Sub

Private Sub OrderClient_OnLogonSucceed()
   Dim oAct As MbtAccount, oActs As MbtAccounts
   Set oActs = OrderClient.Accounts
   For Each oAct In oActs
      oAct.Load
   Next
   Print "Got event: OrderClient_OnLogonSucceed"
   Print
   cmdReturnAccounts.Enabled = True
   cmdReturnAccounts.SetFocus
End Sub

Private Sub cmdReturnAccounts_Click()
   Dim i As Integer, j As Integer
   Dim ano As String, cus As String
   Dim oAccts As MbtAccounts
   Dim oAcct As MbtAccount
   
   Set oAccts = OrderClient.Accounts
   i = oAccts.Count
   Print i & " account(s)"

   Print
   Print "Using For/Next to iterate Accounts:"
   oAccts.LockItems ' using For/Next, need to lock
   For j = 0 To i - 1
      Set oAcct = oAccts.Item(j)
      ano = oAcct.Account
      Print " " & (j + 1) & ". " & ano
   Next
   oAccts.UnlockItems

   Print
   Print "Using For/Each to iterate Accounts:"
   For Each oAcct In oAccts
      ano = oAcct.Account
      Print ano
   Next

   Set oAcct = oAccts.DefaultAccount
   ano = oAcct.Account
   cus = oAcct.Customer
   Print
   Print "Default account: " & ano & " " & cus
   Print
End Sub

Private Sub cmdClear_Click()
   Me.Cls
End Sub


