VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5190
   ClientLeft      =   1065
   ClientTop       =   345
   ClientWidth     =   9090
   LinkTopic       =   "Form1"
   ScaleHeight     =   5190
   ScaleWidth      =   9090
   Begin RichTextLib.RichTextBox rtb 
      Height          =   975
      Left            =   120
      TabIndex        =   4
      Top             =   1680
      Width           =   3615
      _ExtentX        =   6376
      _ExtentY        =   1720
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   3
      TextRTF         =   $"fetchOrderHistory.frx":0000
   End
   Begin VB.TextBox txtPwd 
      Height          =   375
      Left            =   1560
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   60
      Width           =   1335
   End
   Begin VB.TextBox txtUID 
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   60
      Width           =   1335
   End
   Begin VB.CommandButton cmdFetchOrderHistory 
      Caption         =   "&Fetch Order History"
      Height          =   350
      Left            =   5190
      TabIndex        =   3
      Top             =   60
      Width           =   1695
   End
   Begin VB.CommandButton cmdLogin 
      Caption         =   "&Log in"
      Height          =   350
      Left            =   3300
      TabIndex        =   2
      Top             =   60
      Width           =   1695
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
' Quick demonstration of the correct way to instantiate the ComMgr
' singleton, reference the Order Client object, and fetch and list
' the history of orders for the day.
'
' Also includes sample code showing how to derive average price
' for each OrderID.
'
' The key is to wait for the Orders's OnLogonSucceed event
' to fire before trying to fetch Account, Balance, or Order info.
'
' Always remember to destroy objects that you've created in
' reverse order of their creation.
'
' Compatible with Navigator Version 10.13.0.4 and up
'

Private WithEvents ComMgr As MbtComMgr
Attribute ComMgr.VB_VarHelpID = -1
Private WithEvents Orders As MbtOrderClient
Attribute Orders.VB_VarHelpID = -1

Private Const VALUE_BUY = 10000
Private Const VALUE_SELL = 10001
Private Const VALUE_SELLSHT = 10002

Private Sub Form_Load()
   Me.Show
   
   Set ComMgr = New MbtComMgr
   Set Orders = ComMgr.OrderClient
   Orders.OnDemandMode = True
   Me.Caption = Me.Caption & " - Nav ver: " & ComMgr.NavVersion
   
   cmdFetchOrderHistory.Enabled = False
   cmdLogin.Enabled = True
   cmdLogin.SetFocus
   txtUID.Text = UCase(GetSetting("fetchOrderHistory", "Settings", "UID", ""))
   txtPwd.Text = GetSetting("fetchOrderHistory", "Settings", "PWD", "")
   rtb.Text = ""
End Sub

Private Sub Form_Unload(Cancel As Integer)
   ' Clean up (reverse order preferred)
   Set Orders = Nothing
   Set ComMgr = Nothing
   SaveSetting "fetchOrderHistory", "Settings", "UID", UCase(txtUID.Text)
   SaveSetting "fetchOrderHistory", "Settings", "PWD", txtPwd.Text
   Unload Me
End Sub

Private Sub cmdLogin_Click()
   Dim bLoggedIn As Boolean
   rtbAdd ""
   rtbAdd "cmdLogin_Click - DoLogin() now..."
   bLoggedIn = ComMgr.DoLogin(9, txtUID.Text, txtPwd.Text, "")
   rtbAdd "DoLogin returned [" & bLoggedIn & "]"
   If bLoggedIn Then cmdLogin.Enabled = False
End Sub

Private Sub Orders_OnLogonSucceed()
   ' All accounts are now loaded.
   Dim oAct As MbtAccount, oActs As MbtAccounts
   Set oActs = Orders.Accounts
   For Each oAct In oActs
      oAct.Load
   Next
   cmdFetchOrderHistory.Enabled = True
   cmdFetchOrderHistory.SetFocus
   rtbAdd "OnLogonSucceed event received. You can query for the order history now."
End Sub

Private Sub cmdFetchOrderHistory_Click()
   Dim OHs As MbtOrderHistories
   Dim OH As MbtOrderHistory
   Dim BS As String, OE As String, c As Long, i As Long, j As Long, sStr As String
   
   ' Let's set up some arrays for average price calculations
   Dim iCnt As Integer
   Dim bFnd As Boolean

   Dim sOID(9999) As String
   Dim lQty(9999) As Long
   Dim dAmt(9999) As Double

   Dim sTOID As String
   Dim lTQty As Long
   Dim dTPrc As Double
   
   cmdFetchOrderHistory.Enabled = False
   rtbAdd "Querying for order history now..."
   
   ' Grab OrderHistories collection
   Set OHs = Orders.OrderHistories
   
   ' How many orders do we have?
   c = OHs.Count
   rtbAdd "Show " & c & " history items:"

   iCnt = -1
   For Each OH In OHs

      BS = _
         IIf(OH.BuySell = VALUE_BUY, "Buy", ( _
         IIf(OH.BuySell = VALUE_SELL, "Sell", ( _
         IIf(OH.BuySell = VALUE_SELLSHT, "Short", OH.BuySell) _
      ))))
      
      OE = OH.Event

      ' Are we looking at an execution? If so, we need to accumulate the
      ' total Quantity in lQty() and accumulate the $Amount (Quantity * Price)
      ' in dAmt(). After listing ALL history items, we'll summarize the average
      ' prices we've collected for each OrderID found.
      '
      ' Quantity: only those shares that filled in THIS execution (might be a partial)
      ' Price: the price at which THESE shares filled
      '
      ' Remember that .SharesFilled is NOT a valid field - do not use it.
      '
      If OE = "Executed" Then
         sTOID = OH.OrderNumber
         lTQty = OH.Quantity
         dTPrc = OH.Price
         bFnd = False                    ' Always assume we have a new OrderID
         If iCnt > -1 Then               ' If not just starting out...
            For j = 0 To iCnt
               If sTOID = sOID(j) Then   ' ... then try to find a match
                  bFnd = True            ' ... and accumulate if we have a match.
                  lQty(j) = lQty(j) + lTQty
                  dAmt(j) = dAmt(j) + (lTQty * dTPrc)
               End If
            Next
         End If
         If Not bFnd Then                ' Just starting out? Or perhaps no match?
            iCnt = iCnt + 1              ' ... so add another array item.
            sOID(iCnt) = sTOID
            lQty(iCnt) = lTQty
            dAmt(iCnt) = lTQty * dTPrc
         End If
        
      End If ' OE = "Executed"
      
      ' Proceed to list this history item:
      ' NOTE: SharesFilled below should always be zero (deprecated)
      sStr = "  " & (i + 1) & ". " & _
         OH.OrderNumber & "   " & _
         OE & "   " & _
         BS & "   " & _
         OH.Quantity & "   " & _
         OH.Symbol & "  on  " & _
         OH.Route & "  at  " & _
         OH.Price & "  for  " & _
         OH.Account.Account & ":" & _
         OH.Account.Customer & " sf:" & _
         OH.SharesFilled & "  " & _
         OH.Message
      rtbAdd sStr

      Set OrderHistory = Nothing
   Next
   Set OrderHistories = Nothing
   
   ' Now display the average price for each OrderID found in
   ' our OrderHistories collection:
   rtbAdd ""
   rtbAdd "Show Average Prices for each OrderID:"
   If iCnt > -1 Then
      For i = 0 To iCnt
         sStr = "  " & sOID(i) & "  =  " & FormatCurrency(dAmt(i) / lQty(i), 6, vbFalse, vbFalse, vbTrue)
         rtbAdd sStr
      Next
   End If
   
End Sub

Private Sub Form_Resize()
   rtb.Left = 5
   rtb.Top = 480
   rtb.Width = Form1.Width - 110
   rtb.Height = Form1.Height - 880
End Sub

Private Function rtbAdd(sStr As String)
   rtb.Text = rtb.Text & vbNewLine & sStr
End Function
