VERSION 5.00
Begin VB.Form frmPositions 
   Caption         =   "Extract Positions"
   ClientHeight    =   7335
   ClientLeft      =   1065
   ClientTop       =   345
   ClientWidth     =   8820
   LinkTopic       =   "Form1"
   ScaleHeight     =   7335
   ScaleWidth      =   8820
   Begin VB.CommandButton cmdList 
      Caption         =   "List"
      Height          =   375
      Left            =   4560
      TabIndex        =   4
      Top             =   120
      Width           =   855
   End
   Begin VB.TextBox txtUID 
      Height          =   345
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txtPwd 
      Height          =   345
      IMEMode         =   3  'DISABLE
      Left            =   1440
      PasswordChar    =   "O"
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   375
      Left            =   5460
      TabIndex        =   5
      Top             =   120
      Width           =   855
   End
   Begin VB.CommandButton cmdLogin 
      Caption         =   "Log In"
      Height          =   375
      Left            =   2760
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
   Begin VB.CommandButton cmdRetPos 
      Caption         =   "Get"
      Height          =   375
      Left            =   3660
      TabIndex        =   3
      Top             =   120
      Width           =   855
   End
   Begin VB.Label lblQuote 
      Caption         =   "Label1"
      Height          =   255
      Left            =   6480
      TabIndex        =   6
      Top             =   180
      Width           =   795
   End
End
Attribute VB_Name = "frmPositions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Implements IMbtQuotesNotify

Private WithEvents moComMgr As MbtComMgr
Attribute moComMgr.VB_VarHelpID = -1
Private WithEvents moOrders As MbtOrderClient
Attribute moOrders.VB_VarHelpID = -1
Private WithEvents moQuotes As MbtQuotes
Attribute moQuotes.VB_VarHelpID = -1

Private mlPosCnt As Long
Private mdaQts(999) As Double
Private msaSyms(999) As String
Private mlaQty(999) As Long
Private mdCurrAcctEquity As Double
Private mdRealPnL As Double
Private mdCash As Double
Private mbLoggedIn As Boolean

Private Sub Form_Load()
   Me.Show
   cmdLogin.Enabled = True
   cmdRetPos.Enabled = False
   cmdList.Enabled = False
   Set moComMgr = New MbtComMgr
   Set moOrders = moComMgr.OrderClient
   Set moQuotes = moComMgr.Quotes
   moOrders.OnDemandMode = True
   txtUID.Text = UCase(GetSetting("fetchPositions", "Settings", "UID", ""))
   txtPwd.Text = GetSetting("fetchPositions", "Settings", "PWD", "")
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Set moQuotes = Nothing
   Set moOrders = Nothing
   Set moComMgr = Nothing
   SaveSetting "fetchPositions", "Settings", "UID", UCase(txtUID.Text)
   SaveSetting "fetchPositions", "Settings", "PWD", txtPwd.Text
'   Unload Me
End Sub

Private Sub cmdLogin_Click()
   cmdLogin.Enabled = False
   Print: Print: Print
   Print "moComMgr.DoLogin 9, '" & txtUID.Text & "', '" & txtPwd.Text & "', ''"
   If Not moComMgr.DoLogin(9, txtUID.Text, txtPwd.Text, "") Then
      Unload Me
      Exit Sub
   End If
   Print "Waiting for OLS..."
End Sub

Private Sub moOrders_OnLogonSucceed()
   Print "Got event: moOrders_OnLogonSucceed"
   Dim oAct As MbtAccount, oActs As MbtAccounts
   Set oActs = moOrders.Accounts
   For Each oAct In oActs
      Print "manual oAct.Load for " & oAct.Account & "..."
      oAct.Load
   Next
   cmdRetPos.Enabled = True
   cmdRetPos.SetFocus
End Sub

Private Sub moOrders_OnAccountLoaded(ByVal pAcct As MBTORDERSLib.IMbtAccount)
   Print "event fire: " & pAcct.Account & " LOADED !"
End Sub

Private Sub moOrders_OnAccountLoading(ByVal pAcct As MBTORDERSLib.IMbtAccount)
   Print "event fire: " & pAcct.Account & " is loading..."
End Sub

Private Sub cmdRetPos_Click()
   Dim oPos As MbtPosition, oPoss As MbtPositions
   Print
   Set oPoss = moOrders.Positions
   moQuotes.UnadviseAll Me
   mlPosCnt = 0
   For Each oPos In oPoss
   If oPos.AggregatePosition <> 0 Then
      mlPosCnt = mlPosCnt + 1
      msaSyms(mlPosCnt) = oPos.Symbol
      mlaQty(mlPosCnt) = oPos.AggregatePosition
      moQuotes.AdviseSymbol Me, oPos.Symbol, qsfLevelOne
   End If
      Set oPos = Nothing
   Next
   Set oPoss = Nothing
   Print "Found " & mlPosCnt & " position(s)"
   cmdList.Enabled = True
   cmdList.SetFocus
End Sub

Private Sub cmdList_Click()
   Dim dTotPosVal As Double, dRealPnL As Double
   Dim oAcct As MbtAccount
   Set oAcct = moOrders.Accounts.DefaultAccount
   dTotPosVal = 0
   dRealPnL = oAcct.DailyRealizedPL
   Print mlPosCnt & " positions found"
   Dim i As Integer
   For i = 1 To mlPosCnt
      Dim d9 As Double
      d9 = mlaQty(i) * mdaQts(i)
      Print msaSyms(i), mlaQty(i), mdaQts(i), d9
      dTotPosVal = dTotPosVal + d9
   Next i
   Print "TOTAL POSITION VALUE                     ", dTotPosVal
End Sub

Private Sub cmdClear_Click()
   Me.Cls
   Print: Print: Print
End Sub

Private Sub txtUID_GotFocus()
   txtUID.SelLength = Len(txtUID.Text)
End Sub

Private Sub txtPwd_GotFocus()
   txtPwd.SelLength = Len(txtPwd.Text)
End Sub

Private Sub IMbtQuotesNotify_OnQuoteData(pQuote As MBTQUOTELib.QUOTERECORD)
   Dim sSym As String
   Dim dLast As Double
   Dim lVol As Long
   Dim i9 As Integer
   sSym = pQuote.bstrSymbol
   dLast = pQuote.dLast
   lblQuote.Caption = dLast
   For i9 = 0 To mlPosCnt
      If msaSyms(i9) = sSym Then
         mdaQts(i9) = dLast
         Exit Sub
      End If
   Next
End Sub

Private Sub IMbtQuotesNotify_OnLevel2Data(pRec As MBTQUOTELib.LEVEL2RECORD)
End Sub

Private Sub IMbtQuotesNotify_OnOptionsData(pRec As MBTQUOTELib.OPTIONSRECORD)
End Sub

Private Sub IMbtQuotesNotify_OnTSData(pRec As MBTQUOTELib.TSRECORD)
End Sub

