VERSION 5.00
Begin VB.Form frmRoutes 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Extract Routes"
   ClientHeight    =   4980
   ClientLeft      =   1050
   ClientTop       =   330
   ClientWidth     =   2190
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4980
   ScaleWidth      =   2190
   ShowInTaskbar   =   0   'False
   Begin VB.ListBox lstAllRoutes 
      Height          =   2790
      Left            =   120
      TabIndex        =   3
      Top             =   2040
      Width           =   1095
   End
   Begin VB.ListBox lstSymRoutes 
      Height          =   2790
      Left            =   1320
      TabIndex        =   2
      Top             =   2040
      Width           =   735
   End
   Begin VB.CommandButton cmdReturnRoutes 
      Caption         =   "Advise!"
      Height          =   375
      Left            =   1080
      TabIndex        =   1
      Top             =   120
      Width           =   975
   End
   Begin VB.TextBox txtSymbol 
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   855
   End
   Begin VB.Label lblConame 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C00000&
      Height          =   615
      Left            =   120
      TabIndex        =   6
      Top             =   600
      Width           =   1935
   End
   Begin VB.Label Label2 
      Caption         =   "Market && Routes enabled:"
      Height          =   615
      Left            =   1320
      TabIndex        =   5
      Top             =   1320
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Available routes for this login:"
      Height          =   615
      Left            =   120
      TabIndex        =   4
      Top             =   1320
      Width           =   855
   End
End
Attribute VB_Name = "frmRoutes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
' Quick demonstration of iterating the MbtOrderClient.Routes collection
'
' NOTES:
'
' Always remember to destroy objects that you've created in
' reverse order of their creation.
'
' 1. Log in. You will see the left listbox populate with all routes
'    for which the login is permissioned.
'
' 2. Enter a symbol and AdviseSymbol it.
'
' 3. Wait for a callback that gives you a valid bstrMarket (may not
' be the first callback).
'
' 4. Iterate the MbtRoutes collection and see if each route is supported

Option Explicit
Implements IMbtQuotesNotify
Private WithEvents g_ComMgr As MbtComMgr
Attribute g_ComMgr.VB_VarHelpID = -1
Private WithEvents g_Orders As MbtOrderClient
Attribute g_Orders.VB_VarHelpID = -1
Private g_Quotes As MbtQuotes
Private g_Routes As MbtRoutes
Private g_Route As MbtRoute
Private SDKID As Long

Private Sub cmdReturnRoutes_Click()
   ReturnRoutes
End Sub

Private Sub ReturnRoutes()
   Dim sSym As String, lFlag As Long
   g_Quotes.UnadviseAll Me ' Ensure no syms are advised
   lstSymRoutes.Clear
   lstSymRoutes.AddItem "? ! ?"
   lblConame.Caption = "? ! ?"
   sSym = Trim(UCase(txtSymbol.Text))
   txtSymbol.Text = sSym
   If Len(sSym) > 0 Then
      lFlag = 1
      g_Quotes.AdviseSymbol Me, sSym, lFlag
   End If
   txtSymbol.SelLength = Len(txtSymbol.Text)
End Sub

Private Sub Form_Load()
   Me.Show
   cmdReturnRoutes.Enabled = False
   
   Set g_ComMgr = New MbtComMgr
   Set g_Orders = g_ComMgr.OrderClient
   Set g_Quotes = g_ComMgr.Quotes
   g_ComMgr.EnableSplash False
   g_Orders.SilentMode = True
   
   ' Please use your SDK ID here:
   SDKID = 9
   If Not g_ComMgr.DoLogin(SDKID, "", "", "") Then
      Unload Me
      Exit Sub
   End If
   cmdReturnRoutes.Enabled = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
   g_Quotes.UnadviseAll Me
   Set g_Routes = Nothing
   Set g_Quotes = Nothing
   Set g_Orders = Nothing
   Set g_ComMgr = Nothing
   Unload Me
End Sub

Private Sub g_Orders_OnLogonSucceed()
   Set g_Routes = g_ComMgr.OrderClient.Routes
   lstAllRoutes.AddItem g_Routes.Count & " routes:"
   lstAllRoutes.AddItem "========"
   For Each g_Route In g_Routes
      lstAllRoutes.AddItem g_Route.Name
   Next
End Sub

Private Sub IMbtQuotesNotify_OnQuoteData(pQuote As MBTQUOTELib.QUOTERECORD)
   Dim sSym As String, sMarket As String, sTmp As String
   sSym = pQuote.bstrSymbol
   sMarket = pQuote.bstrMarket
   If Len(Trim(sMarket)) > 0 Then
      lblConame.Caption = pQuote.bstrCompany
      lstSymRoutes.Clear
      lstSymRoutes.AddItem sMarket
      lstSymRoutes.AddItem "======"
      For Each g_Route In g_Routes
         sTmp = IIf(g_Route.IsExchangeSupported(sMarket), "YES", "no")
         lstSymRoutes.AddItem sTmp
      Next
      g_Quotes.UnadviseAll Me
   End If
End Sub

Private Sub IMbtQuotesNotify_OnLevel2Data(pRec As MBTQUOTELib.LEVEL2RECORD)
End Sub

Private Sub IMbtQuotesNotify_OnOptionsData(pRec As MBTQUOTELib.OPTIONSRECORD)
End Sub

Private Sub IMbtQuotesNotify_OnTSData(pRec As MBTQUOTELib.TSRECORD)
End Sub

Private Sub txtSymbol_KeyUp(KeyCode As Integer, Shift As Integer)
   If KeyCode = 13 Then ReturnRoutes
End Sub
