VERSION 5.00
Object = "{3AF128DE-C93E-409B-8402-964D81E36F93}#2.0#0"; "MbtGrids.ocx"
Begin VB.Form frmWatchlists 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Extract Watchlist Names"
   ClientHeight    =   9030
   ClientLeft      =   1050
   ClientTop       =   330
   ClientWidth     =   8775
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   9030
   ScaleWidth      =   8775
   ShowInTaskbar   =   0   'False
   Begin VB.ListBox lstNames 
      Height          =   2400
      Left            =   120
      TabIndex        =   5
      Top             =   6480
      Width           =   2895
   End
   Begin VB.CommandButton cmdAddSymbol 
      Caption         =   "Add Symbol"
      Height          =   375
      Left            =   7320
      TabIndex        =   4
      Top             =   7560
      Width           =   1335
   End
   Begin VB.TextBox txtSymbol 
      Height          =   375
      Left            =   6360
      TabIndex        =   3
      Top             =   7560
      Width           =   855
   End
   Begin VB.CommandButton cmdSetFirstWatchlist 
      Caption         =   "Display Selected Watchlist"
      Height          =   375
      Left            =   6360
      TabIndex        =   2
      Top             =   6960
      Width           =   2295
   End
   Begin MBTGRIDSLib.MbtWatch MbtWatch1 
      Height          =   6375
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   8775
      _Version        =   131072
      _ExtentX        =   15478
      _ExtentY        =   11245
      _StockProps     =   2
      Caption         =   "Watchlist -  (No Accounts) "
      Watchlist       =   ""
   End
   Begin VB.CommandButton cmdReturnWatchlists 
      Caption         =   "Return Watchlist Names"
      Height          =   375
      Left            =   6360
      TabIndex        =   0
      Top             =   6480
      Width           =   2295
   End
   Begin VB.Label lblSelSym 
      Caption         =   "Selected symbol"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   3180
      TabIndex        =   6
      Top             =   6540
      Width           =   2895
   End
End
Attribute VB_Name = "frmWatchlists"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
' Quick demonstration of the correct way to instantiate the ComMgr
' singleton, reference the Prefs object, and fetch Watchlist names.
' 02/13/04 - Demonstrate AddSymbol - Phil
'
' NOTES:
'
' Always remember to destroy objects that you've created in
' reverse order of their creation.
'
' It is always wisest to perform the ComMgr.DoLogin method before
' instantiating any controls (showing any forms). Do this in the
' forms Initialize, before Form_Load is called.
'

Option Explicit
Private WithEvents ComMgr As MbtComMgr
Attribute ComMgr.VB_VarHelpID = -1
Private WithEvents Prefs As MbtPrefs
Attribute Prefs.VB_VarHelpID = -1
Private bDoneLogin As Boolean

' Before our Form is even shown, we need to perform DoLogin
' and fetch Prefs, which contains Watchlist names.
Private Sub Form_Initialize()
   Set ComMgr = New MbtComMgr
   ComMgr.EnableSplash False
   bDoneLogin = ComMgr.DoLogin(9, "", "", "")
   If bDoneLogin Then
      Set Prefs = ComMgr.Prefs
   End If
End Sub

Private Sub Form_Load()
   If Not bDoneLogin Then
      Unload Me
      Exit Sub
   End If
   Me.Show
   cmdReturnWatchlists.Enabled = True
   cmdSetFirstWatchlist.Enabled = True
End Sub

Private Sub cmdReturnWatchlists_Click()
   Dim i
   Dim j As Variant
   i = Split(Prefs.GetWatchlistNames, ",")
   lstNames.Clear
   For Each j In i
      lstNames.AddItem j
   Next
   Print
End Sub

Private Sub cmdSetFirstWatchlist_Click()
   MbtWatch1.SetDefaultWatchlist
End Sub

Private Sub cmdAddSymbol_Click()
   Dim sSym As String
   sSym = UCase(Trim("" & txtSymbol.Text))
   If Len(sSym) > 0 Then
      MbtWatch1.AddSymbol sSym
      txtSymbol.Text = sSym
   End If
End Sub

' To save symbols added to the Watchlist, move the dtors and
' serialization of prefs here rather than Form_Unload
Private Sub Form_Terminate()
   MsgBox "Terminating form and serializing prefs. Please wait five seconds after hitting OK."
   Prefs.Serialize True, True
   Set Prefs = Nothing
   Set ComMgr = Nothing
   MsgBox "DONE. Click OK to end."
End Sub

Private Sub Form_Unload(Cancel As Integer)
'   MsgBox "un"
'   Set Prefs = Nothing
'   Set ComMgr = Nothing
'   MsgBox "unDone"
End Sub

Private Sub MbtWatch1_OnManualSymbolFocusChanged(ByVal Symbol As String)
   lblSelSym.Caption = "Selected symbol: " & Symbol
End Sub

